/* sr.c - send and receive routines, main level */

#include "mpi.h"

MPI_Isend( handle, start, count, datatype, dest, tag, comm )
MPI_HANDLE       *handle;
void             *start;
int              count;
MPI_DATATYPE     datatype;
int              dest;
int              tag;
MPI_COMMUNICATOR comm;
{
    MPI_Comm_Init( handle, datatype, dest, tag, comm,
		   MPI_STANDARD, MPI_PERSISTENT);
    (*handle)->shandle.bufadd = start;
    MPI_Start( *handle );
}
MPI_Irecv( handle, start, count, datatype, source, tag, comm )
MPI_HANDLE       *handle;
void             *start;
int              count;
MPI_DATATYPE     datatype;
int              source;
int              tag;
MPI_COMMUNICATOR comm;
{
    MPI_Comm_Init( handle, datatype, source, tag, comm,
		   MPI_RECV, MPI_PERSISTENT);
    (*handle)->rhandle.bufadd = start;
    MPI_Start( *handle );
}

MPI_Wait ( handle, status )
MPI_HANDLE  handle;
MPI_STATUS  *status;
{
    MPI_STATUS *status1 = status;

    MPI_Waitall( 1, &handle, &status1 );
}

MPI_Test ( handle, flag, status )
MPI_HANDLE  handle;
int         *flag;
MPI_STATUS  *status;
{
    int        index;
    MPI_HANDLE handle1 = handle;
    MPI_STATUS *status1 = status;

    MPI_Testany( 1, &handle1, &index, &status1 );
    if (index == 1)
	*flag = 1;
    else
	*flag = 0;
}
